<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Untitled Document</title>
</head>

<body>
<?php
// Starting a session
$params = array(
	'trace' => 1,
	'soap_version' => SOAP_1_1);
$BHClient = new SoapClient("https://api.bullhornstaffing.com/webservices-1.1/?wsdl",$params);
 
$username = "your username";
$password = "your password";
$apiKey = "your apiKey ";

$session_request = new stdClass(); 
$session_request->username = $username; 
$session_request->password = $password;
$session_request->apiKey = $apiKey;
$API_session = $BHClient->startSession($session_request);
$API_currentSession = $API_session->return; 

//Creating a note DTO

$note_array = array(
	'action' => 'Sample',
	'commentingPersonID' => $API_currentSession->userId,
	'comments' => 'This is the best note ever, coming from PHP.',

	/* Use the candidates user Id that you retrieve in the code below. We are defining the variable $thisCandidate as an example. */
	'personReferenceID' => new SoapVar($thisCandidate->userID, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema") //
);

// Saving the note DTO

$SOAP_dto = new SoapVar($note_array, SOAP_ENC_OBJECT, "noteDto", "http://note.entity.bullhorn.com/");

$request_array = array(
	'session' => $API_currentSession,
	'dto' => $SOAP_dto
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "save", "http://save.apiservice.bullhorn.com/");

try{
	$saveResponse = $BHClient->save($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $saveResponse->return->session;
$savedNoteDto = $saveResponse->return->dto;

// Adding Note references

// Associate the note with a candidate
/* Use the candidates user Id that you retrieve in the code below. We are defining the variable $thisCandidate as an example. */

$request_array = array(
	'session' => $API_currentSession, 
	'noteId' => new SoapVar($savedNoteDto->noteID, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema"),
	'entityName' => 'Candidate',
	'entityId' => new SoapVar($thisCandidate->userID, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema") 
	);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "addNoteReference", "http://apiservice.bullhorn.com/");

try{
	$addNoteReferenceResponse = $BHClient->addNoteReference($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $addNoteReferenceResponse->return->session;

// Associate the note with a job order
/* Use the Jobs Id that you are adding a reference to in the code below. We are defining the variable $thisJobOrder as an example. */

$request_array = array(
	'session' => $API_currentSession, 
	'noteId' => new SoapVar($savedNoteDto->noteID, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema"),
	'entityName' => 'JobOrder',
	'entityId' => new SoapVar($thisJobOrder->jobOrderID, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema") // 
	);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "addNoteReference", "http://apiservice.bullhorn.com/");

try{
	$addNoteReferenceResponse = $BHClient->addNoteReference($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $addNoteReferenceResponse->return->session;

// Remove a note reference
/* Retrieve the client contact id before running the code below. We are defining the variable thisClientContact as an example. */

$request_array = array(
	'session' => $API_currentSession,
	'noteId' => new SoapVar($savedNoteDto->noteID, XSD_INTEGER, "int", "http://www.w3.org/2001/XMLSchema"),
	'entityName' => 'ClientContact',
	'entityId' => new SoapVar($thisClientContact->userID, XSD_INTEGER, "int", "http://www.w3.org/2001/XMLSchema")
);
	
$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "removeNoteReference", "http://apiservice.bullhorn.com/");

try{
	$removeNoteReferenceResponse = $BHClient->removeNoteReference($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->_getLastRequest());
	die($fault->faultstring);
}


// Using the getEntityNotes function

/* The candidate ID 6710 below is used as an example. Please use the ID of the candidate on your account. */

$request_array = array(
	'session' => $API_currentSession, 
	'entityName' => 'Candidate',
	'id' => new SoapVar(6710, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema") 
	);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "getEntityNotes", "http://apiservice.bullhorn.com/");

try{
	$getEntityNotesResponse = $BHClient->getEntityNotes($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $getEntityNotesResponse->return->session;

foreach ($getEntityNotesResponse->return->ids as $value){
	$findId = new SoapVar($value, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema");

	$find_request = array (
		'session' => $API_currentSession,
		'entityName' => 'Note',
		'id' => $findId
	);

	try{
		$findResult = $BHClient->find($find_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}

		$API_currentSession = $findResult->return->session;
		$thisNote = $findResult->return->dto;
				
		echo('Found Note using find(): '.$thisNote->comments.'<br>');

}
 
// Using getEntityNotesWhere

/* The candidate ID 6710 below is used as an example. Please use the ID of the candidate on your account. */

$request_array = array(
	'session' => $API_currentSession, 
	'entityName' => 'Candidate',
	'id' => new SoapVar(6710, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema"),
	'notesWhere' => "note.action = 'sample'"
	);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "getEntityNotesWhere", "http://apiservice.bullhorn.com/");

try{
	$getEntityNotesWhereResponse = $BHClient->getEntityNotesWhere($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $getEntityNotesWhereResponse->return->session;

foreach ($getEntityNotesWhereResponse->return->ids as $value){
	$findId = new SoapVar($value, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema");

	$find_request = array (
		'session' => $API_currentSession,
		'entityName' => 'Note',
		'id' => $findId
	);

	try{
		$findResult = $BHClient->find($find_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}

		$API_currentSession = $findResult->return->session;
		$thisNote = $findResult->return->dto;
				
		echo('Found Note with action of sample using find(): '.$thisNote->comments.'<br>');

}





?>
</body>
</html>

